﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
//using UnityEditor;
using UnityEngine.SceneManagement;

public class GameController : MonoBehaviour
{
    private int ResultScenario;

    private int StageIndex;

	[SerializeField]
    private StageData _CurrentStage;
    public StageData CurrentStage
    {
        get
        {
			return _CurrentStage;
        }
    }

    // Use this for initialization
    void Start()
    {

        string Scenename = SceneManager.GetActiveScene().name;
        StageIndex = int.Parse(Scenename.Substring(5));

        ResultScenario = 0;
    }

    // Update is called once per frame
    void Update()
    {
        if (ResultScenario != 0)
        {
            if (Input.GetButtonDown("Submit_P1") || Input.GetButtonDown("Submit_P2") || Input.GetButtonDown("Submit_Base"))
            {
                TriggerResult();
            }
        }
        else if (Input.GetButtonDown("Back_Base"))
        {
            SceneManager.LoadScene("Stage" + (StageIndex).ToString());
        }
    }

    /// <summary>
    /// Move to next stage
    /// </summary>
    public void StageWin()
    {
        Debug.Log("Triggered Win");
        //GameObject.Find("WinningDuck").SetActive(true);
        ResultScenario = 1;

    }

    /// <summary>
    /// Resetart Current Stage
    /// </summary>
    public void StageRestart()
    {
        Debug.Log("Triggered Reset");
        ResultScenario = 2;

    }

    private void TriggerResult()
    {
        if (ResultScenario == 1)
        {
			if (StageIndex == 7) {
				SceneManager.LoadScene("TitleMenu");
			}
			else
				SceneManager.LoadScene("Stage" + (StageIndex + 1).ToString());
        }
        else if (ResultScenario == 2)
        {
            SceneManager.LoadScene("Stage" + (StageIndex).ToString());
        }
    }
}
